import pyglet, random
pyglet.options['debug_gl'] = False
from pyglet.window import key
from tools import info_X_Y
from sprites import game_Logo, map_Block, flyer_s, commit_buttom
from sprites import clear_buttom, empty_buttom, regen_buttom, select_buttom
from graphics2d import draw_rect, draw_line
from question_and_answer import question_and_answer

class numberWindow(pyglet.window.Window):
    def __init__(self, *args, **kwargs):
        super(numberWindow, self).__init__(800, 600, caption="Kill H1N1")
        
        pyglet.font.add_file('static/ADVERTMF.TTF')
        
        self.batch = pyglet.graphics.Batch()
        self.game_start_batch = pyglet.graphics.Batch()

        self.set_center()
        self.hit = 0
#        self.flyer_alive = 0
        self.start_game = 0
        self.level = self.level_start = 1
        self.q_a = 0
        self.score = 0
        self.draw_speed_line_x = 475
        self.game_speed = 5
        self.update_count = 0
        self.update_flyer_location = 1
        self.hold_more_then_five = False
        self.select_sound = 1
        self.chipchip_play = 0
        
        self.label = pyglet.text.Label('Kill         H1N1',
            font_name='Advert MF',
            font_size=40,
            x=self.width//2, y=self.height//2,
            anchor_x='center', anchor_y='center', batch=self.game_start_batch)
        
        self.viruses_logo = flyer_s()
        self.viruses_logo.x = self.width//2 - 50
        self.viruses_logo.y = self.height//2 - 50
        
        self.answer_list = []
        
        self.set_speel_label = pyglet.text.Label('Set game speed:',
            font_name='Time New Roman',
            font_size=14,
            x = 300, y = 50, anchor_x="center", anchor_y="center", batch=self.game_start_batch) 
        
        self.set_speel_label = pyglet.text.Label('Set sound:',
            font_name='Time New Roman',
            font_size=14,
            x = 300, y = 100, anchor_x="center", anchor_y="center", batch=self.game_start_batch) 
        
        self.start_game_msg_label = pyglet.text.Label('',
            font_name='Time New Roman',
            font_size=12, x = 0, y=0,
            bold = 1, anchor_y="center", anchor_x="left", batch=self.game_start_batch)

        self.gameover_label = pyglet.text.Label('',
            font_name='Time New Roman',
            font_size=48,
            bold = 1,
            anchor_x='center', anchor_y='center',
            x = self.width // 2, y = self.height // 2, batch=self.batch)
        
        self.mouse_label = pyglet.text.Label('Kill H1N1',
            font_name='Advert MF',
            font_size=20,
            x = 620, y = 395, anchor_x="left", anchor_y="top", batch=self.batch)

        self.key_press_msg_label = pyglet.text.Label('',
            font_name='Time New Roman',
            font_size=12,
            x = 0, y = 0, anchor_x="left", anchor_y="top", batch=self.batch)
            
        self.question_label = pyglet.text.Label('your question:',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 350, anchor_x="left", anchor_y="top", batch=self.batch)       
         
        self.sum_answer_label = pyglet.text.Label('your answer:',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 330, anchor_x="left", anchor_y="top", batch=self.batch)
        
        self.mouse_label = pyglet.text.Label('mouse here',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 310, anchor_x="left", anchor_y="top", batch=self.batch)
        
        self.hit_label = pyglet.text.Label('hit: ',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 290, anchor_x='left', anchor_y='top', batch=self.batch)
        
        self.flyer_alive_label = pyglet.text.Label('viruses alive: ',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 270, anchor_x='left', anchor_y='top', batch=self.batch)
            
        self.answer_label = pyglet.text.Label('hold: ',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 250, anchor_x='left', anchor_y='top', batch=self.batch)
            
        self.score_label = pyglet.text.Label('score: ',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 230, anchor_x='left', anchor_y='top', batch=self.batch)
        
        # load image.
        self.mouse_image = pyglet.image.load('static/shoes.gif')
        self.mouse_get_off_image = pyglet.image.load('static/kill.gif')
#        self.mouse_thermometer = pyglet.image.load('static/thermometer_2.gif')
        
        self.cursor = pyglet.window.ImageMouseCursor(self.mouse_image, 45, 62)
        self.get_off_cursor = pyglet.window.ImageMouseCursor(self.mouse_get_off_image, 45, 62)
#        self.thermometer_cursor = pyglet.window.ImageMouseCursor(self.mouse_thermometer, 45, 62)
        
        self.default_cursor = self.get_system_mouse_cursor(self.CURSOR_DEFAULT)
        
        self.set_mouse_cursor(self.cursor)
        
        self.logo_sprite = game_Logo(batch=self.batch)
        self.xy = info_X_Y(self.batch)
        self.commit_buttom = commit_buttom()
        self.clear_buttom = clear_buttom()
        self.empty_buttom = empty_buttom()
        self.regen_buttom = regen_buttom()
        self.select_buttom = select_buttom()
        self.qa = question_and_answer()
        self.update_question()
        self.m_b = []
        self.create_Map_Block()
    
    def set_center(self):
        self.start_x = 2
        self.start_y = 2
    
    def update_question(self):
        self.qa.make_a_question(level = self.level)
        self.question_label.text = 'question: %s' %self.qa.question_text
        self.q_a = self.qa.answer
        self.play_dig()
 
    def create_Map_Block(self):
        point_x_y = self.xy.point_x_y_list
#        label_text_x_y = self.xy.label_text_list
        for n in range(0, len(point_x_y)):
            self.xy.package_screen_list(self.start_x, self.start_y)
#            mb = map_Block(image=self.xy.get_grass_images_list_from_x_y(x, y) ,batch=self.batch)
            mb = map_Block(batch=self.batch)
            mb.x = point_x_y[n][0]
            mb.y = point_x_y[n][1]
            i = random.randint(0,3)
#            mb.image = mb.grass[i]
            mb.label.x = mb.x + 175
            mb.label.y = mb.y + 175
            mb.label.text = self.xy.package_list[n].label             
            self.m_b.append(mb)
        
    def on_draw(self):
        if self.start_game:
            self.clear()
            self.batch.draw()
            for p in self.xy.point_x_y():
                draw_rect(p[0],p[1],200,200, filled=False)
            s_m_p = self.xy.small_point_x_y_list
            for n in range(0, len(s_m_p)):
                if self.xy.map_block_obj_list[n].flyer.alive:
                    draw_rect(s_m_p[n][0], s_m_p[n][1], 25, 25, filled=True)
                    self.xy.map_block_obj_list[n].flyer.draw()
                    # draw the small number.
                    pyglet.text.Label('%s' %self.xy.map_block_obj_list[n].flyer.number,
                        font_name='Advert MF',
                        font_size=40,
                        x = self.xy.map_block_obj_list[n].flyer.x + 100,
                        y = self.xy.map_block_obj_list[n].flyer.y).draw()
                else:
                    draw_rect(s_m_p[n][0], s_m_p[n][1], 25, 25, filled=False)
            draw_rect(610 + (self.start_x * 25), 410 + (self.start_y * 25), 75,75, line_width=5, filled=False)
            if 625 + self.update_flyer_alive() * 10 < 775:
                draw_line(775,165, 625 + self.update_flyer_alive() * 10 , 165, line_width = 10)
            self.commit_buttom.draw()
            self.clear_buttom.draw()
            self.empty_buttom.draw()
            self.regen_buttom.draw()
        else:
            self.clear()
            self.game_start_batch.draw()
            self.viruses_logo.draw()
            self.select_buttom.draw()
            draw_line(400,50, 550, 50)
            draw_line(self.draw_speed_line_x, 45, self.draw_speed_line_x, 55)

    
    # something key handler will re-add under here again.
    def on_key_press(self, symbol, modifiers):
        if symbol == key.ESCAPE:
            self.has_exit = True
        if symbol == key.W:
            if self.start_y < 4: self.start_y +=1
        if symbol == key.S:
            if self.start_y > 0: self.start_y -=1
        if symbol == key.D:
            if self.start_x < 4: self.start_x +=1
        if symbol == key.A:
            if self.start_x > 0: self.start_x -=1
        if symbol == key.Z:
            self.your_answer_commit_handler()
        if symbol == key.X:
            self.your_answer_clear_handler()
        if symbol == key.C:
            self.your_answer_empty_handler()
        if symbol == key.R:
            self.update_question()
        if symbol == key.V:
            self.set_center()
    
    def on_mouse_press(self, x, y, button, modifiers):
        if self.start_game:
            if x < 600:
                self.set_mouse_cursor(self.get_off_cursor)
            else:
                self.set_mouse_cursor(self.default_cursor)
            for o in self.xy.map_block_obj_list:
                if o.flyer and self.shoes_hit_test(x, y, o.flyer):
                    if len(self.answer_list) < 5:
                        self.mouse_label.text = 'hit'
                        o.flyer.alive = False
                        self.hit += 1
    #                    self.flyer_alive -= 1
                        self.hit_label.text = 'hit: %s' %self.hit
                        self.answer_list.append(o.flyer.number)
                    else:
                        self.hold_more_then_five = True 
            if self.hit_test(x, y, self.empty_buttom):
                self.your_answer_empty_handler()
            if self.hit_test(x, y, self.clear_buttom):
                self.your_answer_clear_handler()
#            self.update_answer_label_text()
            if self.hit_test(x, y, self.commit_buttom):
                self.your_answer_commit_handler()
            if self.hit_test(x, y, self.regen_buttom):
                self.update_question()
                
        else:
            if y > 100:
                self.set_mouse_cursor(self.get_off_cursor)
            else:
                self.set_mouse_cursor(self.default_cursor)
            if self.hit_test(x, y, self.select_buttom):
                self.select_buttom.set_image(self.select_sound % 2)
                self.select_sound += 1
            if  self.hit_test(x, y, self.viruses_logo):
                self.start_game = 1
            if ( 400 < x  < 550 and 40 < y < 60 ): 
                self.draw_speed_line_x = x
                self.game_speed = ( x / 10 - 40 ) / 2
    
    def your_answer_empty_handler(self):
        self.answer_list = []
        self.play_dig()
    
    def your_answer_clear_handler(self):
        if len(self.answer_list):
            self.answer_list.pop()
        self.play_dig()

    def your_answer_commit_handler(self):
        sum = 0
        for n in self.answer_list:
            sum += n
        if self.qa.answer == sum or self.qa.answer == sum % 10:
            self.sum_answer_label.text = 'Your answer: %s (right)' %sum
            self.score += self.qa.score
            self.play_right()
            self.score_label.text = 'score: %s' %self.score
            self.update_question()
            # have bug.
            self.level = self.level_start + self.score / 10
        else:
            self.sum_answer_label.text = 'Your answer: %s (wong)' %sum
        self.answer_list = []
        self.play_dig()
#        self.update_answer_label_text() 
                
    def update_key_press_msg_label(self, x, y, msg):
        self.key_press_msg_label.x = x
        self.key_press_msg_label.y = y - 25
        self.key_press_msg_label.text = msg
    
    def on_mouse_motion(self, x, y, dx, dy):
#        if self.hit_test(x, y, self.logo_sprite):
#            self.set_mouse_cursor(self.thermometer_cursor)
#        else:
        if self.start_game:
            if x < 600:
                self.set_mouse_cursor(self.cursor)
            else:
                self.set_mouse_cursor(self.default_cursor)
            self.mouse_label.text = 'x=%s, y=%s' %(x, y)
            
            if self.hit_test(x, y, self.empty_buttom):
                self.update_key_press_msg_label(x - 75, y, 'Use key.C')
            elif self.hit_test(x, y, self.clear_buttom):
                self.update_key_press_msg_label(x, y, 'Use key.X')
#            self.update_answer_label_text()
            elif self.hit_test(x, y, self.commit_buttom):
                self.update_key_press_msg_label(x, y, 'Use key.Z')
            elif self.hit_test(x, y, self.regen_buttom):
                self.update_key_press_msg_label(x - 75, y, 'Use key.R')
            else:
                self.update_key_press_msg_label(x, y, '')
                
        else:
            if  self.hit_test(x, y, self.viruses_logo):
                self.start_game_msg_label.x = x + 50
                self.start_game_msg_label.y = y + 50
                self.start_game_msg_label.text = 'Kill me to start the game'
            else:
                self.start_game_msg_label.text = ''
            if y > 100:
                self.set_mouse_cursor(self.cursor)
            else:
                self.set_mouse_cursor(self.default_cursor)
        
    
    def on_mouse_release(self, x, y, button, modifiers):
        if self.start_game:
            if x < 600:
                self.set_mouse_cursor(self.cursor)
            else:
                self.set_mouse_cursor(self.default_cursor)
        else:
            if y > 100:
                self.set_mouse_cursor(self.cursor)
            else:
               self.set_mouse_cursor(self.default_cursor) 
    
    def play_dig(self):
        if ( self.select_sound - 1 ) % 2:
            pyglet.media.load('static/dig2.ogg', streaming=True).play()
    
    def play_right(self):
        if ( self.select_sound - 1 ) % 2:
            pyglet.media.load('static/mup2.ogg', streaming=True).play() 
    
    def play_game_over(self):
        if ( self.select_sound - 1 ) % 2:
            pyglet.media.load('static/running2.ogg', streaming=True).play()    
        
    def hit_test(self, x, y, s):
        return (0 < x - s.x < s.width and
                0 < y - s.y < s.height)
    
    def shoes_hit_test(self, x, y, s, h=50, w=50):
        hit = (0 < x - s.x < s.width and
                0 < y - s.y < s.height ) or (
                0 < x + ( w / 2 ) - s.x < s.width and
                  0 < y + ( h / 2 ) - s.y < s.height ) or (
                0 < x - ( w / 2 ) - s.x < s.width and
                  0 < y - ( h / 2 ) - s.y < s.width ) or (
                0 < x + ( w / 2 ) - s.x < s.width and
                  0 < y - ( h / 2 ) - s.y < s.height ) or (
                0 < x - ( w / 2 ) - s.x < s.width and
                  0 < y + ( h / 2 ) - s.y < s.height )
        if hit:
            if ( self.select_sound - 1 ) % 2:
                pyglet.media.load('static/shoes2.ogg', streaming=True).play()
        return hit
    
    def update(self, dt):
        if self.start_game:
            self.update_count += 1
            if ( self.select_sound - 1 ) % 2:
                if self.chipchip_play == 0:
                    chipchip = pyglet.media.load('static/chipchip2.ogg', streaming=True)
                    chipchip.play()
                    self.chipchip_play = 1
#            self.flyer_alive = self.update_flyer_alive()
            for n in range(0, len(self.xy.point_x_y_list)):
                if self.update_count % ( 9 - self.game_speed ) == 1:
                    self.update_flyer_location = 1
                else:
                    self.update_flyer_location = 0
                get_n = self.xy.package_screen_list(start_x=self.start_x, start_y=self.start_y,
                    update_flyer_location=self.update_flyer_location)
                self.m_b[n].label.text = self.xy.package_list[n].label
                self.m_b[n].image = self.xy.package_list[n].block_image
            if self.update_flyer_alive() > 15:
                self.set_mouse_visible(False)
                self.gameover_label.text = "Game Over"
                self.play_game_over()

#            self.flyer_alive_label.text = 'viruses alive: %s' %self.flyer_alive
            self.flyer_alive = self.update_flyer_alive()
            self.update_answer_label_text()
            self.update_flyer()
            if len(self.answer_list) < 5: self.more_then_five = False
    
    def update_flyer_alive(self):
        flyer_alive = 0
        for n in range(0, 49):
            if self.xy.map_block_obj_list[n].flyer.alive == True:
                flyer_alive += 1
        self.flyer_alive_label.text = 'viruses alive: %s' %flyer_alive
        return flyer_alive
    
    def update_answer_label_text(self):        
        if len(self.answer_list):
            if not self.hold_more_then_five:
                self.answer_label.text = 'You hold: %s' %self.answer_list[0]
                if len(self.answer_list[1:]):
                    for n in self.answer_list[1:]:
                        self.answer_label.text += ', ' + '%s' %n
            else:
                self.answer_label.text = 'Don\'t hold more then five'
                self.hold_more_then_five = False
        else:
            self.answer_label.text = 'You hold: '
    
    def update_flyer(self):
        flyer_alive = self.update_flyer_alive()
        if flyer_alive < 3:
            for n in range(0, 3 - flyer_alive):
                n = random.randint(0, 48)
                self.xy.map_block_obj_list[n].flyer.alive = True
            
        for n in range(0, 49):
#            if random.randint(0,1000) <= (self.flyer_alive / 50) + 1:
            if random.randint(0,750 * self.game_speed) <= (1 + self.flyer_alive / 5):
                if not self.xy.map_block_obj_list[n].flyer.alive:
                    self.xy.map_block_obj_list[n].flyer.alive = True